using System;

class Test
{
	delegate double Function( double x );
	static double[] Map( Function f, double[] a ) {
		double[] result = new double[a.Length];
		for ( int i = 0; i < a.Length; i++ )
			result[i] = f( a[i] );
		return result;
	}
	static double[] Multiply( double[] a, double factor ) {
		return Map( delegate(double x) { return x * factor; }, a );
	}
	static void Main() {
		double[] a = {0.0, 0.5, 1.0};
		double[] doubles = Multiply(a, 2.0);
		foreach( double i in doubles )
		       Console.WriteLine( i );	
	}
}
