#include <vector>
#include <memory>
#include <algorithm>
#include <functional>

std::auto_ptr< std::vector<double> >
Multiply( std::vector<double> const& a, double factor ) {
	std::auto_ptr< std::vector<double> > result(
		new std::vector<double>( a.size() ) );
	std::transform( a.begin(), a.end(), result->begin(),
		std::bind2nd( std::multiplies<double>(), factor ) );
	return result;
}

int main( int ac, char* av[] ) {
	std::vector<double> a(3);
	double a_init[] = {0.0, 0.5, 1.0};
	std::copy( a_init, a_init+3, a.begin() );
	std::auto_ptr< std::vector<double> > doubles( Multiply( a, 2.0 ) );
	return 0;
}
