#include <malloc.h>

struct TFunction {
	double (*fnc)(double context, double x);
	double context;
};

double Times(double context, double x) {
	return x * context;
}

double* Map_( struct TFunction* f, double const* a, int a_len) {
	double* result = malloc( a_len * sizeof(double) );
	int i = 0;
	for ( ; i < a_len; ++i )
		result[i] = f->fnc( f->context, a[i]);
	return result;
}

double* Multiply( double const* a, int a_len, double factor ) {
	double* rv = 0;
	struct TFunction f;
	f.fnc = &Times;
	f.context = factor;
	rv = Map_( &f, a, a_len );
	return rv;
}

int main( int ac, char* av[] ) {
	double a[] = {0.0, 0.5, 1.0}; 
	double* b = Multiply( a, sizeof(a)/sizeof(double), 2.0 );
	free(b);
	return 0;
}
